<center><a href="nn.c">Actual source code: nn.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:27:56+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../../../src/ksp/pc/impls/is/nn/nn.h.html">src/ksp/pc/impls/is/nn/nn.h</A>

<a name="line5">  5: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line6">  6: </a><font color="#B22222">/*</font>
<a name="line7">  7: </a><font color="#B22222">   PCSetUp_NN - Prepares for the use of the NN preconditioner</font>
<a name="line8">  8: </a><font color="#B22222">                    by setting data structures and options.   </font>

<a name="line10"> 10: </a><font color="#B22222">   Input Parameter:</font>
<a name="line11"> 11: </a><font color="#B22222">.  pc - the preconditioner context</font>

<a name="line13"> 13: </a><font color="#B22222">   Application Interface Routine: <A href="../../../../../../docs/manualpages/PC/PCSetUp.html#PCSetUp">PCSetUp</A>()</font>

<a name="line15"> 15: </a><font color="#B22222">   Notes:</font>
<a name="line16"> 16: </a><font color="#B22222">   The interface routine <A href="../../../../../../docs/manualpages/PC/PCSetUp.html#PCSetUp">PCSetUp</A>() is not usually called directly by</font>
<a name="line17"> 17: </a><font color="#B22222">   the user, but instead is called by <A href="../../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>() if necessary.</font>
<a name="line18"> 18: </a><font color="#B22222">*/</font>
<a name="line21"> 21: </a><strong><font color="#4169E1"><a name="PCSetUp_NN"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCSetUp_NN(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line22"> 22: </a>{
<a name="line24"> 24: </a>
<a name="line26"> 26: </a>  <font color="#4169E1">if</font> (!pc-&gt;setupcalled) {
<a name="line27"> 27: </a>    <font color="#B22222">/* Set up all the "iterative substructuring" common block */</font>
<a name="line28"> 28: </a>    PCISSetUp(pc);
<a name="line29"> 29: </a>    <font color="#B22222">/* Create the coarse matrix. */</font>
<a name="line30"> 30: </a>    PCNNCreateCoarseMatrix(pc);
<a name="line31"> 31: </a>  }
<a name="line32"> 32: </a>  <font color="#4169E1">return</font>(0);
<a name="line33"> 33: </a>}

<a name="line35"> 35: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line36"> 36: </a><font color="#B22222">/*</font>
<a name="line37"> 37: </a><font color="#B22222">   PCApply_NN - Applies the NN preconditioner to a vector.</font>

<a name="line39"> 39: </a><font color="#B22222">   Input Parameters:</font>
<a name="line40"> 40: </a><font color="#B22222">.  pc - the preconditioner context</font>
<a name="line41"> 41: </a><font color="#B22222">.  r - input vector (global)</font>

<a name="line43"> 43: </a><font color="#B22222">   Output Parameter:</font>
<a name="line44"> 44: </a><font color="#B22222">.  z - output vector (global)</font>

<a name="line46"> 46: </a><font color="#B22222">   Application Interface Routine: <A href="../../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>()</font>
<a name="line47"> 47: </a><font color="#B22222"> */</font>
<a name="line50"> 50: </a><strong><font color="#4169E1"><a name="PCApply_NN"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCApply_NN(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> r,<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> z)</font></strong>
<a name="line51"> 51: </a>{
<a name="line52"> 52: </a>  PC_IS          *pcis = (PC_IS*)(pc-&gt;data);
<a name="line54"> 54: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    m_one = -1.0;
<a name="line55"> 55: </a>  <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            w = pcis-&gt;vec1_global;

<a name="line58"> 58: </a>  <font color="#B22222">/*</font>
<a name="line59"> 59: </a><font color="#B22222">    Dirichlet solvers.</font>
<a name="line60"> 60: </a><font color="#B22222">    Solving $ B_I^{(i)}r_I^{(i)} $ at each processor.</font>
<a name="line61"> 61: </a><font color="#B22222">    Storing the local results at vec2_D</font>
<a name="line62"> 62: </a><font color="#B22222">  */</font>
<a name="line63"> 63: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(r,pcis-&gt;vec1_D,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_D);
<a name="line64"> 64: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (r,pcis-&gt;vec1_D,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_D);
<a name="line65"> 65: </a>  <A href="../../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(pcis-&gt;ksp_D,pcis-&gt;vec1_D,pcis-&gt;vec2_D);
<a name="line66"> 66: </a>
<a name="line67"> 67: </a>  <font color="#B22222">/*</font>
<a name="line68"> 68: </a><font color="#B22222">    Computing $ r_B - \sum_j \tilde R_j^T A_{BI}^{(j)} (B_I^{(j)}r_I^{(j)}) $ .</font>
<a name="line69"> 69: </a><font color="#B22222">    Storing the result in the interface portion of the global vector w.</font>
<a name="line70"> 70: </a><font color="#B22222">  */</font>
<a name="line71"> 71: </a>  <A href="../../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(pcis-&gt;A_BI,pcis-&gt;vec2_D,pcis-&gt;vec1_B);
<a name="line72"> 72: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScale.html#VecScale">VecScale</A>(pcis-&gt;vec1_B,m_one);
<a name="line73"> 73: </a>  <A href="../../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(r,w);
<a name="line74"> 74: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(pcis-&gt;vec1_B,w,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line75"> 75: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (pcis-&gt;vec1_B,w,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);

<a name="line77"> 77: </a>  <font color="#B22222">/*</font>
<a name="line78"> 78: </a><font color="#B22222">    Apply the interface preconditioner</font>
<a name="line79"> 79: </a><font color="#B22222">  */</font>
<a name="line80"> 80: </a>  PCNNApplyInterfacePreconditioner(pc,w,z,pcis-&gt;work_N,pcis-&gt;vec1_B,pcis-&gt;vec2_B,pcis-&gt;vec3_B,pcis-&gt;vec1_D,
<a name="line81"> 81: </a>                                          pcis-&gt;vec3_D,pcis-&gt;vec1_N,pcis-&gt;vec2_N);

<a name="line83"> 83: </a>  <font color="#B22222">/*</font>
<a name="line84"> 84: </a><font color="#B22222">    Computing $ t_I^{(i)} = A_{IB}^{(i)} \tilde R_i z_B $</font>
<a name="line85"> 85: </a><font color="#B22222">    The result is stored in vec1_D.</font>
<a name="line86"> 86: </a><font color="#B22222">  */</font>
<a name="line87"> 87: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(z,pcis-&gt;vec1_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line88"> 88: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (z,pcis-&gt;vec1_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line89"> 89: </a>  <A href="../../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(pcis-&gt;A_IB,pcis-&gt;vec1_B,pcis-&gt;vec1_D);

<a name="line91"> 91: </a>  <font color="#B22222">/*</font>
<a name="line92"> 92: </a><font color="#B22222">    Dirichlet solvers.</font>
<a name="line93"> 93: </a><font color="#B22222">    Computing $ B_I^{(i)}t_I^{(i)} $ and sticking into the global vector the blocks</font>
<a name="line94"> 94: </a><font color="#B22222">    $ B_I^{(i)}r_I^{(i)} - B_I^{(i)}t_I^{(i)} $.</font>
<a name="line95"> 95: </a><font color="#B22222">  */</font>
<a name="line96"> 96: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(pcis-&gt;vec2_D,z,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_D);
<a name="line97"> 97: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (pcis-&gt;vec2_D,z,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_D);
<a name="line98"> 98: </a>  <A href="../../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(pcis-&gt;ksp_D,pcis-&gt;vec1_D,pcis-&gt;vec2_D);
<a name="line99"> 99: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScale.html#VecScale">VecScale</A>(pcis-&gt;vec2_D,m_one);
<a name="line100">100: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(pcis-&gt;vec2_D,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_D);
<a name="line101">101: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (pcis-&gt;vec2_D,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_D);
<a name="line102">102: </a>  <font color="#4169E1">return</font>(0);
<a name="line103">103: </a>}

<a name="line105">105: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line106">106: </a><font color="#B22222">/*</font>
<a name="line107">107: </a><font color="#B22222">   PCDestroy_NN - Destroys the private context for the NN preconditioner</font>
<a name="line108">108: </a><font color="#B22222">   that was created with PCCreate_NN().</font>

<a name="line110">110: </a><font color="#B22222">   Input Parameter:</font>
<a name="line111">111: </a><font color="#B22222">.  pc - the preconditioner context</font>

<a name="line113">113: </a><font color="#B22222">   Application Interface Routine: <A href="../../../../../../docs/manualpages/PC/PCDestroy.html#PCDestroy">PCDestroy</A>()</font>
<a name="line114">114: </a><font color="#B22222">*/</font>
<a name="line117">117: </a><strong><font color="#4169E1"><a name="PCDestroy_NN"></a>static <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCDestroy_NN(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line118">118: </a>{
<a name="line119">119: </a>  PC_NN          *pcnn = (PC_NN*)pc-&gt;data;

<a name="line123">123: </a>  PCISDestroy(pc);

<a name="line125">125: </a>  <font color="#4169E1">if</font> (pcnn-&gt;coarse_mat)  {<A href="../../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(pcnn-&gt;coarse_mat);}
<a name="line126">126: </a>  <font color="#4169E1">if</font> (pcnn-&gt;coarse_x)    {<A href="../../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(pcnn-&gt;coarse_x);}
<a name="line127">127: </a>  <font color="#4169E1">if</font> (pcnn-&gt;coarse_b)    {<A href="../../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(pcnn-&gt;coarse_b);}
<a name="line128">128: </a>  <font color="#4169E1">if</font> (pcnn-&gt;ksp_coarse) {<A href="../../../../../../docs/manualpages/KSP/KSPDestroy.html#KSPDestroy">KSPDestroy</A>(pcnn-&gt;ksp_coarse);}
<a name="line129">129: </a>  <font color="#4169E1">if</font> (pcnn-&gt;DZ_IN) {
<a name="line130">130: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(pcnn-&gt;DZ_IN[0]);
<a name="line131">131: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(pcnn-&gt;DZ_IN);
<a name="line132">132: </a>  }

<a name="line134">134: </a>  <font color="#B22222">/*</font>
<a name="line135">135: </a><font color="#B22222">      Free the private data structure that was hanging off the <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A></font>
<a name="line136">136: </a><font color="#B22222">  */</font>
<a name="line137">137: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(pcnn);
<a name="line138">138: </a>  <font color="#4169E1">return</font>(0);
<a name="line139">139: </a>}

<a name="line141">141: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line142">142: </a><font color="#B22222">/*MC</font>
<a name="line143">143: </a><font color="#B22222">   <A href="../../../../../../docs/manualpages/PC/PCNN.html#PCNN">PCNN</A> - Balancing Neumann-Neumann for scalar elliptic PDEs.</font>

<a name="line145">145: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line146">146: </a><font color="#B22222">+    -pc_nn_turn_off_first_balancing - do not balance the residual before solving the local Neumann problems</font>
<a name="line147">147: </a><font color="#B22222">                                       (this skips the first coarse grid solve in the preconditioner)</font>
<a name="line148">148: </a><font color="#B22222">.    -pc_nn_turn_off_second_balancing - do not balance the solution solving the local Neumann problems</font>
<a name="line149">149: </a><font color="#B22222">                                       (this skips the second coarse grid solve in the preconditioner)</font>
<a name="line150">150: </a><font color="#B22222">.    -pc_is_damp_fixed &lt;fact&gt; -</font>
<a name="line151">151: </a><font color="#B22222">.    -pc_is_remove_nullspace_fixed -</font>
<a name="line152">152: </a><font color="#B22222">.    -pc_is_set_damping_factor_floating &lt;fact&gt; -</font>
<a name="line153">153: </a><font color="#B22222">.    -pc_is_not_damp_floating -</font>
<a name="line154">154: </a><font color="#B22222">+    -pc_is_not_remove_nullspace_floating - </font>

<a name="line156">156: </a><font color="#B22222">   Level: intermediate</font>

<a name="line158">158: </a><font color="#B22222">   Notes: The matrix used with this preconditioner must be of type <A href="../../../../../../docs/manualpages/Mat/MATIS.html#MATIS">MATIS</A> </font>

<a name="line160">160: </a><font color="#B22222">          Unlike more 'conventional' Neumann-Neumann preconditioners this iterates over ALL the</font>
<a name="line161">161: </a><font color="#B22222">          degrees of freedom, NOT just those on the interface (this allows the use of approximate solvers</font>
<a name="line162">162: </a><font color="#B22222">          on the subdomains; though in our experience using approximate solvers is slower.).</font>

<a name="line164">164: </a><font color="#B22222">          Options for the coarse grid preconditioner can be set with -nn_coarse_pc_xxx</font>
<a name="line165">165: </a><font color="#B22222">          Options for the Dirichlet subproblem preconditioner can be set with -is_localD_pc_xxx</font>
<a name="line166">166: </a><font color="#B22222">          Options for the Neumann subproblem preconditioner can be set with -is_localN_pc_xxx</font>

<a name="line168">168: </a><font color="#B22222">   Contributed by Paulo Goldfeld</font>

<a name="line170">170: </a><font color="#B22222">.seealso:  <A href="../../../../../../docs/manualpages/PC/PCCreate.html#PCCreate">PCCreate</A>(), <A href="../../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(), <A href="../../../../../../docs/manualpages/PC/PCType.html#PCType">PCType</A> (for list of available types), <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>,  MatIS</font>
<a name="line171">171: </a><font color="#B22222">M*/</font>
<a name="line175">175: </a><strong><font color="#4169E1"><a name="PCCreate_NN"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  PCCreate_NN(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line176">176: </a>{
<a name="line178">178: </a>  PC_NN          *pcnn;

<a name="line181">181: </a>  <font color="#B22222">/*</font>
<a name="line182">182: </a><font color="#B22222">     Creates the private data structure for this preconditioner and</font>
<a name="line183">183: </a><font color="#B22222">     attach it to the <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> object.</font>
<a name="line184">184: </a><font color="#B22222">  */</font>
<a name="line185">185: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscNew.html#PetscNew">PetscNew</A>(PC_NN,&amp;pcnn);
<a name="line186">186: </a>  pc-&gt;data  = (void*)pcnn;

<a name="line188">188: </a>  <font color="#B22222">/*</font>
<a name="line189">189: </a><font color="#B22222">     Logs the memory usage; this is not needed but allows PETSc to </font>
<a name="line190">190: </a><font color="#B22222">     monitor how much memory is being used for various purposes.</font>
<a name="line191">191: </a><font color="#B22222">  */</font>
<a name="line192">192: </a>  PetscLogObjectMemory(pc,<font color="#4169E1">sizeof</font>(PC_NN)+<font color="#4169E1">sizeof</font>(PC_IS)); <font color="#B22222">/* Is this the right thing to do? */</font>

<a name="line194">194: </a>  PCISCreate(pc);
<a name="line195">195: </a>  pcnn-&gt;coarse_mat  = 0;
<a name="line196">196: </a>  pcnn-&gt;coarse_x    = 0;
<a name="line197">197: </a>  pcnn-&gt;coarse_b    = 0;
<a name="line198">198: </a>  pcnn-&gt;ksp_coarse = 0;
<a name="line199">199: </a>  pcnn-&gt;DZ_IN       = 0;

<a name="line201">201: </a>  <font color="#B22222">/*</font>
<a name="line202">202: </a><font color="#B22222">      Set the pointers for the functions that are provided above.</font>
<a name="line203">203: </a><font color="#B22222">      Now when the user-level routines (such as <A href="../../../../../../docs/manualpages/PC/PCApply.html#PCApply">PCApply</A>(), <A href="../../../../../../docs/manualpages/PC/PCDestroy.html#PCDestroy">PCDestroy</A>(), etc.)</font>
<a name="line204">204: </a><font color="#B22222">      are called, they will automatically call these functions.  Note we</font>
<a name="line205">205: </a><font color="#B22222">      choose not to provide a couple of these functions since they are</font>
<a name="line206">206: </a><font color="#B22222">      not needed.</font>
<a name="line207">207: </a><font color="#B22222">  */</font>
<a name="line208">208: </a>  pc-&gt;ops-&gt;apply               = PCApply_NN;
<a name="line209">209: </a>  pc-&gt;ops-&gt;applytranspose      = 0;
<a name="line210">210: </a>  pc-&gt;ops-&gt;setup               = PCSetUp_NN;
<a name="line211">211: </a>  pc-&gt;ops-&gt;destroy             = PCDestroy_NN;
<a name="line212">212: </a>  pc-&gt;ops-&gt;view                = 0;
<a name="line213">213: </a>  pc-&gt;ops-&gt;applyrichardson     = 0;
<a name="line214">214: </a>  pc-&gt;ops-&gt;applysymmetricleft  = 0;
<a name="line215">215: </a>  pc-&gt;ops-&gt;applysymmetricright = 0;
<a name="line216">216: </a>  <font color="#4169E1">return</font>(0);
<a name="line217">217: </a>}


<a name="line221">221: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line222">222: </a><font color="#B22222">/*</font>
<a name="line223">223: </a><font color="#B22222">   PCNNCreateCoarseMatrix - </font>
<a name="line224">224: </a><font color="#B22222">*/</font>
<a name="line227">227: </a><strong><font color="#4169E1"><a name="PCNNCreateCoarseMatrix"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCNNCreateCoarseMatrix (<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc)</font></strong>
<a name="line228">228: </a>{
<a name="line229">229: </a>  MPI_Request    *send_request, *recv_request;
<a name="line231">231: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i, j, k;
<a name="line232">232: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>*   mat;    <font color="#B22222">/* Sub-matrix with this subdomain's contribution to the coarse matrix             */</font>
<a name="line233">233: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>**  DZ_OUT; <font color="#B22222">/* proc[k].DZ_OUT[i][] = bit of vector to be sent from processor k to processor i */</font>

<a name="line235">235: </a>  <font color="#B22222">/* aliasing some names */</font>
<a name="line236">236: </a>  PC_IS*         pcis     = (PC_IS*)(pc-&gt;data);
<a name="line237">237: </a>  PC_NN*         pcnn     = (PC_NN*)pc-&gt;data;
<a name="line238">238: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       n_neigh  = pcis-&gt;n_neigh;
<a name="line239">239: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*      neigh    = pcis-&gt;neigh;
<a name="line240">240: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>*      n_shared = pcis-&gt;n_shared;
<a name="line241">241: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>**     shared   = pcis-&gt;shared;
<a name="line242">242: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>**  DZ_IN;   <font color="#B22222">/* Must be initialized after memory allocation. */</font>

<a name="line245">245: </a>  <font color="#B22222">/* Allocate memory for mat (the +1 is to handle the case n_neigh equal to zero) */</font>
<a name="line246">246: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n_neigh*n_neigh+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;mat);

<a name="line248">248: </a>  <font color="#B22222">/* Allocate memory for DZ */</font>
<a name="line249">249: </a>  <font color="#B22222">/* Notice that DZ_OUT[0] is allocated some space that is never used. */</font>
<a name="line250">250: </a>  <font color="#B22222">/* This is just in order to DZ_OUT and DZ_IN to have exactly the same form. */</font>
<a name="line251">251: </a>  {
<a name="line252">252: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> size_of_Z = 0;
<a name="line253">253: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A> ((n_neigh+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>*),&amp;pcnn-&gt;DZ_IN);
<a name="line254">254: </a>    DZ_IN = pcnn-&gt;DZ_IN;
<a name="line255">255: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A> ((n_neigh+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>*),&amp;DZ_OUT);
<a name="line256">256: </a>    <font color="#4169E1">for</font> (i=0; i&lt;n_neigh; i++) {
<a name="line257">257: </a>      size_of_Z += n_shared[i];
<a name="line258">258: </a>    }
<a name="line259">259: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A> ((size_of_Z+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;DZ_IN[0]);
<a name="line260">260: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A> ((size_of_Z+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;DZ_OUT[0]);
<a name="line261">261: </a>  }
<a name="line262">262: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n_neigh; i++) {
<a name="line263">263: </a>    DZ_IN[i]  = DZ_IN [i-1] + n_shared[i-1];
<a name="line264">264: </a>    DZ_OUT[i] = DZ_OUT[i-1] + n_shared[i-1];
<a name="line265">265: </a>  }

<a name="line267">267: </a>  <font color="#B22222">/* Set the values of DZ_OUT, in order to send this info to the neighbours */</font>
<a name="line268">268: </a>  <font color="#B22222">/* First, set the auxiliary array pcis-&gt;work_N. */</font>
<a name="line269">269: </a>  PCISScatterArrayNToVecB(pcis-&gt;work_N,pcis-&gt;D,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pc);
<a name="line270">270: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n_neigh; i++){
<a name="line271">271: </a>    <font color="#4169E1">for</font> (j=0; j&lt;n_shared[i]; j++) {
<a name="line272">272: </a>      DZ_OUT[i][j] = pcis-&gt;work_N[shared[i][j]];
<a name="line273">273: </a>    }
<a name="line274">274: </a>  }

<a name="line276">276: </a>  <font color="#B22222">/* Non-blocking send/receive the common-interface chunks of scaled nullspaces */</font>
<a name="line277">277: </a>  <font color="#B22222">/* Notice that send_request[] and recv_request[] could have one less element. */</font>
<a name="line278">278: </a>  <font color="#B22222">/* We make them longer to have request[i] corresponding to neigh[i].          */</font>
<a name="line279">279: </a>  {
<a name="line280">280: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> tag;
<a name="line281">281: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscObjectGetNewTag.html#PetscObjectGetNewTag">PetscObjectGetNewTag</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,&amp;tag);
<a name="line282">282: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((2*(n_neigh)+1)*<font color="#4169E1">sizeof</font>(MPI_Request),&amp;send_request);
<a name="line283">283: </a>    recv_request = send_request + (n_neigh);
<a name="line284">284: </a>    <font color="#4169E1">for</font> (i=1; i&lt;n_neigh; i++) {
<a name="line285">285: </a>      <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Isend.html#MPI_Isend">MPI_Isend</A>((void*)(DZ_OUT[i]),n_shared[i],<A href="../../../../../../docs/manualpages/Sys/MPIU_SCALAR.html#MPIU_SCALAR">MPIU_SCALAR</A>,neigh[i],tag,pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(send_request[i]));
<a name="line286">286: </a>      <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Irecv.html#MPI_Irecv">MPI_Irecv</A>((void*)(DZ_IN [i]),n_shared[i],<A href="../../../../../../docs/manualpages/Sys/MPIU_SCALAR.html#MPIU_SCALAR">MPIU_SCALAR</A>,neigh[i],tag,pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(recv_request[i]));
<a name="line287">287: </a>    }
<a name="line288">288: </a>  }

<a name="line290">290: </a>  <font color="#B22222">/* Set DZ_IN[0][] (recall that neigh[0]==<A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>, always) */</font>
<a name="line291">291: </a>  <font color="#4169E1">for</font>(j=0; j&lt;n_shared[0]; j++) {
<a name="line292">292: </a>    DZ_IN[0][j] = pcis-&gt;work_N[shared[0][j]];
<a name="line293">293: </a>  }

<a name="line295">295: </a>  <font color="#B22222">/* Start computing with local D*Z while communication goes on.    */</font>
<a name="line296">296: </a>  <font color="#B22222">/* Apply Schur complement. The result is "stored" in vec (more    */</font>
<a name="line297">297: </a>  <font color="#B22222">/* precisely, vec points to the result, stored in pc_nn-&gt;vec1_B)  */</font>
<a name="line298">298: </a>  <font color="#B22222">/* and also scattered to pcnn-&gt;work_N.                            */</font>
<a name="line299">299: </a>  PCNNApplySchurToChunk(pc,n_shared[0],shared[0],DZ_IN[0],pcis-&gt;work_N,pcis-&gt;vec1_B,
<a name="line300">300: </a>                               pcis-&gt;vec2_B,pcis-&gt;vec1_D,pcis-&gt;vec2_D);

<a name="line302">302: </a>  <font color="#B22222">/* Compute the first column, while completing the receiving. */</font>
<a name="line303">303: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n_neigh; i++) {
<a name="line304">304: </a>    MPI_Status  stat;
<a name="line305">305: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> ind=0;
<a name="line306">306: </a>    <font color="#4169E1">if</font> (i&gt;0) { <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Waitany.html#MPI_Waitany">MPI_Waitany</A>(n_neigh-1,recv_request+1,&amp;ind,&amp;stat); ind++;}
<a name="line307">307: </a>    mat[ind*n_neigh+0] = 0.0;
<a name="line308">308: </a>    <font color="#4169E1">for</font> (k=0; k&lt;n_shared[ind]; k++) {
<a name="line309">309: </a>      mat[ind*n_neigh+0] += DZ_IN[ind][k] * pcis-&gt;work_N[shared[ind][k]];
<a name="line310">310: </a>    }
<a name="line311">311: </a>  }

<a name="line313">313: </a>  <font color="#B22222">/* Compute the remaining of the columns */</font>
<a name="line314">314: </a>  <font color="#4169E1">for</font> (j=1; j&lt;n_neigh; j++) {
<a name="line315">315: </a>    PCNNApplySchurToChunk(pc,n_shared[j],shared[j],DZ_IN[j],pcis-&gt;work_N,pcis-&gt;vec1_B,
<a name="line316">316: </a>                                 pcis-&gt;vec2_B,pcis-&gt;vec1_D,pcis-&gt;vec2_D);
<a name="line317">317: </a>    <font color="#4169E1">for</font> (i=0; i&lt;n_neigh; i++) {
<a name="line318">318: </a>      mat[i*n_neigh+j] = 0.0;
<a name="line319">319: </a>      <font color="#4169E1">for</font> (k=0; k&lt;n_shared[i]; k++) {
<a name="line320">320: </a>        mat[i*n_neigh+j] += DZ_IN[i][k] * pcis-&gt;work_N[shared[i][k]];
<a name="line321">321: </a>      }
<a name="line322">322: </a>    }
<a name="line323">323: </a>  }

<a name="line325">325: </a>  <font color="#B22222">/* Complete the sending. */</font>
<a name="line326">326: </a>  <font color="#4169E1">if</font> (n_neigh&gt;1) {
<a name="line327">327: </a>    MPI_Status *stat;
<a name="line328">328: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n_neigh-1)*<font color="#4169E1">sizeof</font>(MPI_Status),&amp;stat);
<a name="line329">329: </a>    <font color="#4169E1">if</font> (n_neigh-1) {<A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Waitall.html#MPI_Waitall">MPI_Waitall</A>(n_neigh-1,&amp;(send_request[1]),stat);}
<a name="line330">330: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(stat);
<a name="line331">331: </a>  }

<a name="line333">333: </a>  <font color="#B22222">/* Free the memory for the MPI requests */</font>
<a name="line334">334: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(send_request);

<a name="line336">336: </a>  <font color="#B22222">/* Free the memory for DZ_OUT */</font>
<a name="line337">337: </a>  <font color="#4169E1">if</font> (DZ_OUT) {
<a name="line338">338: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(DZ_OUT[0]);
<a name="line339">339: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(DZ_OUT);
<a name="line340">340: </a>  }

<a name="line342">342: </a>  {
<a name="line343">343: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line344">344: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line345">345: </a>    <font color="#B22222">/* Create the global coarse vectors (rhs and solution). */</font>
<a name="line346">346: </a>    <A href="../../../../../../docs/manualpages/Vec/VecCreateMPI.html#VecCreateMPI">VecCreateMPI</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,1,<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>,&amp;(pcnn-&gt;coarse_b));
<a name="line347">347: </a>    <A href="../../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(pcnn-&gt;coarse_b,&amp;(pcnn-&gt;coarse_x));
<a name="line348">348: </a>    <font color="#B22222">/* Create and set the global coarse AIJ matrix. */</font>
<a name="line349">349: </a>    <A href="../../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(pcnn-&gt;coarse_mat));
<a name="line350">350: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(pcnn-&gt;coarse_mat,1,1,<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>,<A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line351">351: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(pcnn-&gt;coarse_mat,<A href="../../../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>);
<a name="line352">352: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A>(pcnn-&gt;coarse_mat,1,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line353">353: </a>    <A href="../../../../../../docs/manualpages/Mat/MatMPIAIJSetPreallocation.html#MatMPIAIJSetPreallocation">MatMPIAIJSetPreallocation</A>(pcnn-&gt;coarse_mat,1,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,1,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line354">354: </a>    <A href="../../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(pcnn-&gt;coarse_mat,n_neigh,neigh,n_neigh,neigh,mat,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line355">355: </a>    <A href="../../../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(pcnn-&gt;coarse_mat,MAT_FINAL_ASSEMBLY);
<a name="line356">356: </a>    <A href="../../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>  (pcnn-&gt;coarse_mat,MAT_FINAL_ASSEMBLY);
<a name="line357">357: </a>  }

<a name="line359">359: </a>  {
<a name="line360">360: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> <A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line361">361: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> one = 1.0;
<a name="line362">362: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line363">363: </a>    <font color="#B22222">/* "Zero out" rows of not-purely-Neumann subdomains */</font>
<a name="line364">364: </a>    <font color="#4169E1">if</font> (pcis-&gt;pure_neumann) {  <font color="#B22222">/* does NOT zero the row; create an empty index set. The reason is that <A href="../../../../../../docs/manualpages/Mat/MatZeroRows.html#MatZeroRows">MatZeroRows</A>() is collective. */</font>
<a name="line365">365: </a>      <A href="../../../../../../docs/manualpages/Mat/MatZeroRows.html#MatZeroRows">MatZeroRows</A>(pcnn-&gt;coarse_mat,0,<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,one);
<a name="line366">366: </a>    } <font color="#4169E1">else</font> { <font color="#B22222">/* here it DOES zero the row, since it's not a floating subdomain. */</font>
<a name="line367">367: </a>      <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> row = (<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>) <A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line368">368: </a>      <A href="../../../../../../docs/manualpages/Mat/MatZeroRows.html#MatZeroRows">MatZeroRows</A>(pcnn-&gt;coarse_mat,1,&amp;row,one);
<a name="line369">369: </a>    }
<a name="line370">370: </a>  }

<a name="line372">372: </a>  <font color="#B22222">/* Create the coarse linear solver context */</font>
<a name="line373">373: </a>  {
<a name="line374">374: </a>    <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>  pc_ctx, inner_pc;
<a name="line375">375: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;pcnn-&gt;ksp_coarse);
<a name="line376">376: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(pcnn-&gt;ksp_coarse,pcnn-&gt;coarse_mat,pcnn-&gt;coarse_mat,SAME_PRECONDITIONER);
<a name="line377">377: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPGetPC.html#KSPGetPC">KSPGetPC</A>(pcnn-&gt;ksp_coarse,&amp;pc_ctx);
<a name="line378">378: </a>    <A href="../../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(pc_ctx,<A href="../../../../../../docs/manualpages/PC/PCREDUNDANT.html#PCREDUNDANT">PCREDUNDANT</A>);
<a name="line379">379: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(pcnn-&gt;ksp_coarse,<A href="../../../../../../docs/manualpages/KSP/KSPPREONLY.html#KSPPREONLY">KSPPREONLY</A>);
<a name="line380">380: </a>    <A href="../../../../../../docs/manualpages/PC/PCRedundantGetPC.html#PCRedundantGetPC">PCRedundantGetPC</A>(pc_ctx,&amp;inner_pc);
<a name="line381">381: </a>    <A href="../../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(inner_pc,<A href="../../../../../../docs/manualpages/PC/PCLU.html#PCLU">PCLU</A>);
<a name="line382">382: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetOptionsPrefix.html#KSPSetOptionsPrefix">KSPSetOptionsPrefix</A>(pcnn-&gt;ksp_coarse,<font color="#666666">"nn_coarse_"</font>);
<a name="line383">383: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(pcnn-&gt;ksp_coarse);
<a name="line384">384: </a>    <font color="#B22222">/* the vectors in the following line are dummy arguments, just telling the <A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> the vector <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A>. Values are not used */</font>
<a name="line385">385: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetUp.html#KSPSetUp">KSPSetUp</A>(pcnn-&gt;ksp_coarse);
<a name="line386">386: </a>  }

<a name="line388">388: </a>  <font color="#B22222">/* Free the memory for mat */</font>
<a name="line389">389: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(mat);

<a name="line391">391: </a>  <font color="#B22222">/* for DEBUGGING, save the coarse matrix to a file. */</font>
<a name="line392">392: </a>  {
<a name="line393">393: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flg;
<a name="line394">394: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-pc_nn_save_coarse_matrix"</font>,&amp;flg);
<a name="line395">395: </a>    <font color="#4169E1">if</font> (flg) {
<a name="line396">396: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A> viewer;
<a name="line397">397: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerASCIIOpen.html#PetscViewerASCIIOpen">PetscViewerASCIIOpen</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"coarse.m"</font>,&amp;viewer);
<a name="line398">398: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(viewer,PETSC_VIEWER_ASCII_MATLAB);
<a name="line399">399: </a>      <A href="../../../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(pcnn-&gt;coarse_mat,viewer);
<a name="line400">400: </a>      <A href="../../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);
<a name="line401">401: </a>    }
<a name="line402">402: </a>  }

<a name="line404">404: </a>  <font color="#B22222">/*  Set the variable pcnn-&gt;factor_coarse_rhs. */</font>
<a name="line405">405: </a>  pcnn-&gt;factor_coarse_rhs = (pcis-&gt;pure_neumann) ? 1.0 : 0.0;

<a name="line407">407: </a>  <font color="#B22222">/* See historical note 02, at the bottom of this file. */</font>
<a name="line408">408: </a>  <font color="#4169E1">return</font>(0);
<a name="line409">409: </a>}

<a name="line411">411: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line412">412: </a><font color="#B22222">/*</font>
<a name="line413">413: </a><font color="#B22222">   PCNNApplySchurToChunk - </font>

<a name="line415">415: </a><font color="#B22222">   Input parameters:</font>
<a name="line416">416: </a><font color="#B22222">.  pcnn</font>
<a name="line417">417: </a><font color="#B22222">.  n - <A href="../../../../../../docs/manualpages/Sys/size.html#size">size</A> of chunk</font>
<a name="line418">418: </a><font color="#B22222">.  idx - indices of chunk</font>
<a name="line419">419: </a><font color="#B22222">.  chunk - values</font>

<a name="line421">421: </a><font color="#B22222">   Output parameters:</font>
<a name="line422">422: </a><font color="#B22222">.  array_N - result of Schur complement applied to chunk, scattered to big array</font>
<a name="line423">423: </a><font color="#B22222">.  vec1_B  - result of Schur complement applied to chunk</font>
<a name="line424">424: </a><font color="#B22222">.  vec2_B  - garbage (used as work space)</font>
<a name="line425">425: </a><font color="#B22222">.  vec1_D  - garbage (used as work space)</font>
<a name="line426">426: </a><font color="#B22222">.  vec2_D  - garbage (used as work space)</font>

<a name="line428">428: </a><font color="#B22222">*/</font>
<a name="line431">431: </a><strong><font color="#4169E1"><a name="PCNNApplySchurToChunk"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCNNApplySchurToChunk(<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n, <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>* idx, <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *chunk, <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>* array_N, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_D, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_D)</font></strong>
<a name="line432">432: </a>{
<a name="line434">434: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;
<a name="line435">435: </a>  PC_IS          *pcis = (PC_IS*)(pc-&gt;data);

<a name="line438">438: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>((void*)array_N, pcis-&gt;n*<font color="#4169E1">sizeof</font>(<A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>));
<a name="line439">439: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) { array_N[idx[i]] = chunk[i]; }
<a name="line440">440: </a>  PCISScatterArrayNToVecB(array_N,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pc);
<a name="line441">441: </a>  PCISApplySchur(pc,vec2_B,vec1_B,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,vec1_D,vec2_D);
<a name="line442">442: </a>  PCISScatterArrayNToVecB(array_N,vec1_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pc);
<a name="line443">443: </a>  <font color="#4169E1">return</font>(0);
<a name="line444">444: </a>}

<a name="line446">446: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line447">447: </a><font color="#B22222">/*</font>
<a name="line448">448: </a><font color="#B22222">   PCNNApplyInterfacePreconditioner - Apply the interface preconditioner, i.e., </font>
<a name="line449">449: </a><font color="#B22222">                                      the preconditioner for the Schur complement.</font>

<a name="line451">451: </a><font color="#B22222">   Input parameter:</font>
<a name="line452">452: </a><font color="#B22222">.  r - global vector of interior and interface nodes. The values on the interior nodes are NOT used.</font>

<a name="line454">454: </a><font color="#B22222">   Output parameters:</font>
<a name="line455">455: </a><font color="#B22222">.  z - global vector of interior and interface nodes. The values on the interface are the result of</font>
<a name="line456">456: </a><font color="#B22222">       the application of the interface preconditioner to the interface part of r. The values on the</font>
<a name="line457">457: </a><font color="#B22222">       interior nodes are garbage.</font>
<a name="line458">458: </a><font color="#B22222">.  work_N - array of local nodes (interior and interface, including ghosts); returns garbage (used as work space)</font>
<a name="line459">459: </a><font color="#B22222">.  vec1_B - vector of local interface nodes (including ghosts); returns garbage (used as work space)</font>
<a name="line460">460: </a><font color="#B22222">.  vec2_B - vector of local interface nodes (including ghosts); returns garbage (used as work space)</font>
<a name="line461">461: </a><font color="#B22222">.  vec3_B - vector of local interface nodes (including ghosts); returns garbage (used as work space)</font>
<a name="line462">462: </a><font color="#B22222">.  vec1_D - vector of local interior nodes; returns garbage (used as work space)</font>
<a name="line463">463: </a><font color="#B22222">.  vec2_D - vector of local interior nodes; returns garbage (used as work space)</font>
<a name="line464">464: </a><font color="#B22222">.  vec1_N - vector of local nodes (interior and interface, including ghosts); returns garbage (used as work space)</font>
<a name="line465">465: </a><font color="#B22222">.  vec2_N - vector of local nodes (interior and interface, including ghosts); returns garbage (used as work space)</font>

<a name="line467">467: </a><font color="#B22222">*/</font>
<a name="line470">470: </a><strong><font color="#4169E1"><a name="PCNNApplyInterfacePreconditioner"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCNNApplyInterfacePreconditioner (<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> r, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> z, <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>* work_N, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec3_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_D,</font></strong>
<a name="line471">471: </a><strong><font color="#4169E1">                                      <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_D, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_N, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_N)</font></strong>
<a name="line472">472: </a>{
<a name="line474">474: </a>  PC_IS*         pcis = (PC_IS*)(pc-&gt;data);

<a name="line477">477: </a>  <font color="#B22222">/*</font>
<a name="line478">478: </a><font color="#B22222">    First balancing step.</font>
<a name="line479">479: </a><font color="#B22222">  */</font>
<a name="line480">480: </a>  {
<a name="line481">481: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flg;
<a name="line482">482: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-pc_nn_turn_off_first_balancing"</font>,&amp;flg);
<a name="line483">483: </a>    <font color="#4169E1">if</font> (!flg) {
<a name="line484">484: </a>      PCNNBalancing(pc,r,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,z,vec1_B,vec2_B,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,vec1_D,vec2_D,work_N);
<a name="line485">485: </a>    } <font color="#4169E1">else</font> {
<a name="line486">486: </a>      <A href="../../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(r,z);
<a name="line487">487: </a>    }
<a name="line488">488: </a>  }

<a name="line490">490: </a>  <font color="#B22222">/*</font>
<a name="line491">491: </a><font color="#B22222">    Extract the local interface part of z and scale it by D </font>
<a name="line492">492: </a><font color="#B22222">  */</font>
<a name="line493">493: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(z,vec1_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line494">494: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (z,vec1_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line495">495: </a>  <A href="../../../../../../docs/manualpages/Vec/VecPointwiseMult.html#VecPointwiseMult">VecPointwiseMult</A>(vec2_B,pcis-&gt;D,vec1_B);

<a name="line497">497: </a>  <font color="#B22222">/* Neumann Solver */</font>
<a name="line498">498: </a>  PCISApplyInvSchur(pc,vec2_B,vec1_B,vec1_N,vec2_N);

<a name="line500">500: </a>  <font color="#B22222">/*</font>
<a name="line501">501: </a><font color="#B22222">    Second balancing step.</font>
<a name="line502">502: </a><font color="#B22222">  */</font>
<a name="line503">503: </a>  {
<a name="line504">504: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A> flg;
<a name="line505">505: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-pc_turn_off_second_balancing"</font>,&amp;flg);
<a name="line506">506: </a>    <font color="#4169E1">if</font> (!flg) {
<a name="line507">507: </a>      PCNNBalancing(pc,r,vec1_B,z,vec2_B,vec3_B,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,vec1_D,vec2_D,work_N);
<a name="line508">508: </a>    } <font color="#4169E1">else</font> {
<a name="line509">509: </a>      <A href="../../../../../../docs/manualpages/Vec/VecPointwiseMult.html#VecPointwiseMult">VecPointwiseMult</A>(vec2_B,pcis-&gt;D,vec1_B);
<a name="line510">510: </a>      <A href="../../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(z,0.0);
<a name="line511">511: </a>      <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(vec2_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line512">512: </a>      <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (vec2_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line513">513: </a>    }
<a name="line514">514: </a>  }
<a name="line515">515: </a>  <font color="#4169E1">return</font>(0);
<a name="line516">516: </a>}

<a name="line518">518: </a><font color="#B22222">/* -------------------------------------------------------------------------- */</font>
<a name="line519">519: </a><font color="#B22222">/*</font>
<a name="line520">520: </a><font color="#B22222">   PCNNBalancing - Computes z, as given in equations (15) and (16) (if the</font>
<a name="line521">521: </a><font color="#B22222">                   input argument u is provided), or s, as given in equations</font>
<a name="line522">522: </a><font color="#B22222">                   (12) and (13), if the input argument u is a null vector.</font>
<a name="line523">523: </a><font color="#B22222">                   Notice that the input argument u plays the role of u_i in</font>
<a name="line524">524: </a><font color="#B22222">                   equation (14). The equation numbers refer to [Man93].</font>

<a name="line526">526: </a><font color="#B22222">   Input Parameters:</font>
<a name="line527">527: </a><font color="#B22222">.  pcnn - NN preconditioner context.</font>
<a name="line528">528: </a><font color="#B22222">.  r - MPI vector of all nodes (interior and interface). It's preserved.</font>
<a name="line529">529: </a><font color="#B22222">.  u - (Optional) sequential vector of local interface nodes. It's preserved UNLESS vec3_B is null.</font>

<a name="line531">531: </a><font color="#B22222">   Output Parameters:</font>
<a name="line532">532: </a><font color="#B22222">.  z - MPI vector of interior and interface nodes. Returns s or z (see description above).</font>
<a name="line533">533: </a><font color="#B22222">.  vec1_B - Sequential vector of local interface nodes. Workspace.</font>
<a name="line534">534: </a><font color="#B22222">.  vec2_B - Sequential vector of local interface nodes. Workspace.</font>
<a name="line535">535: </a><font color="#B22222">.  vec3_B - (Optional) sequential vector of local interface nodes. Workspace.</font>
<a name="line536">536: </a><font color="#B22222">.  vec1_D - Sequential vector of local interior nodes. Workspace.</font>
<a name="line537">537: </a><font color="#B22222">.  vec2_D - Sequential vector of local interior nodes. Workspace.</font>
<a name="line538">538: </a><font color="#B22222">.  work_N - Array of all local nodes (interior and interface). Workspace.</font>

<a name="line540">540: </a><font color="#B22222">*/</font>
<a name="line543">543: </a><strong><font color="#4169E1"><a name="PCNNBalancing"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> PCNNBalancing (<A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A> pc, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> r, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> u, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> z, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_B, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec3_B,</font></strong>
<a name="line544">544: </a><strong><font color="#4169E1">                   <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec1_D, <A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> vec2_D, <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *work_N)</font></strong>
<a name="line545">545: </a>{
<a name="line547">547: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       k;
<a name="line548">548: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    value;
<a name="line549">549: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>*   lambda;
<a name="line550">550: </a>  PC_NN*         pcnn     = (PC_NN*)(pc-&gt;data);
<a name="line551">551: </a>  PC_IS*         pcis     = (PC_IS*)(pc-&gt;data);

<a name="line555">555: </a>  <font color="#4169E1">if</font> (u) {
<a name="line556">556: </a>    <font color="#4169E1">if</font> (!vec3_B) { vec3_B = u; }
<a name="line557">557: </a>    <A href="../../../../../../docs/manualpages/Vec/VecPointwiseMult.html#VecPointwiseMult">VecPointwiseMult</A>(vec1_B,pcis-&gt;D,u);
<a name="line558">558: </a>    <A href="../../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(z,0.0);
<a name="line559">559: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(vec1_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line560">560: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (vec1_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line561">561: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line562">562: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line563">563: </a>    PCISApplySchur(pc,vec2_B,vec3_B,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,vec1_D,vec2_D);
<a name="line564">564: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScale.html#VecScale">VecScale</A>(vec3_B,-1.0);
<a name="line565">565: </a>    <A href="../../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(r,z);
<a name="line566">566: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(vec3_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line567">567: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (vec3_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line568">568: </a>  } <font color="#4169E1">else</font> {
<a name="line569">569: </a>    <A href="../../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(r,z);
<a name="line570">570: </a>  }
<a name="line571">571: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line572">572: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line573">573: </a>  PCISScatterArrayNToVecB(work_N,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pc);
<a name="line574">574: </a>  <font color="#4169E1">for</font> (k=0, value=0.0; k&lt;pcis-&gt;n_shared[0]; k++) { value += pcnn-&gt;DZ_IN[0][k] * work_N[pcis-&gt;shared[0][k]]; }
<a name="line575">575: </a>  value *= pcnn-&gt;factor_coarse_rhs;  <font color="#B22222">/* This factor is set in CreateCoarseMatrix(). */</font>
<a name="line576">576: </a>  {
<a name="line577">577: </a>    <A href="../../../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A> <A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>;
<a name="line578">578: </a>    <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_rank.html#MPI_Comm_rank">MPI_Comm_rank</A>(pc-&gt;<A href="../../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;<A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>);
<a name="line579">579: </a>    <A href="../../../../../../docs/manualpages/Vec/VecSetValue.html#VecSetValue">VecSetValue</A>(pcnn-&gt;coarse_b,<A href="../../../../../../docs/manualpages/Sys/rank.html#rank">rank</A>,value,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line580">580: </a>    <font color="#B22222">/*</font>
<a name="line581">581: </a><font color="#B22222">       Since we are only inserting local values (one value actually) we don't need to do the </font>
<a name="line582">582: </a><font color="#B22222">       reduction that tells us there is no data that needs to be moved. Hence we comment out these</font>
<a name="line583">583: </a><font color="#B22222">       <A href="../../../../../../docs/manualpages/Vec/VecAssemblyBegin.html#VecAssemblyBegin">VecAssemblyBegin</A>(pcnn-&gt;coarse_b); </font>
<a name="line584">584: </a><font color="#B22222">       <A href="../../../../../../docs/manualpages/Vec/VecAssemblyEnd.html#VecAssemblyEnd">VecAssemblyEnd</A>  (pcnn-&gt;coarse_b);</font>
<a name="line585">585: </a><font color="#B22222">    */</font>
<a name="line586">586: </a>  }
<a name="line587">587: </a>  <A href="../../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(pcnn-&gt;ksp_coarse,pcnn-&gt;coarse_b,pcnn-&gt;coarse_x);
<a name="line588">588: </a>  <font color="#4169E1">if</font> (!u) { <A href="../../../../../../docs/manualpages/Vec/VecScale.html#VecScale">VecScale</A>(pcnn-&gt;coarse_x,-1.0); }
<a name="line589">589: </a>  <A href="../../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(pcnn-&gt;coarse_x,&amp;lambda);
<a name="line590">590: </a>  <font color="#4169E1">for</font> (k=0; k&lt;pcis-&gt;n_shared[0]; k++) { work_N[pcis-&gt;shared[0][k]] = *lambda * pcnn-&gt;DZ_IN[0][k]; }
<a name="line591">591: </a>  <A href="../../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(pcnn-&gt;coarse_x,&amp;lambda);
<a name="line592">592: </a>  PCISScatterArrayNToVecB(work_N,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pc);
<a name="line593">593: </a>  <A href="../../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(z,0.0);
<a name="line594">594: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(vec2_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line595">595: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (vec2_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line596">596: </a>  <font color="#4169E1">if</font> (!u) {
<a name="line597">597: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line598">598: </a>    <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (z,vec2_B,<A href="../../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_FORWARD.html#SCATTER_FORWARD">SCATTER_FORWARD</A>,pcis-&gt;global_to_B);
<a name="line599">599: </a>    PCISApplySchur(pc,vec2_B,vec1_B,(<A href="../../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)0,vec1_D,vec2_D);
<a name="line600">600: </a>    <A href="../../../../../../docs/manualpages/Vec/VecCopy.html#VecCopy">VecCopy</A>(r,z);
<a name="line601">601: </a>  }
<a name="line602">602: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterBegin.html#VecScatterBegin">VecScatterBegin</A>(vec1_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line603">603: </a>  <A href="../../../../../../docs/manualpages/Vec/VecScatterEnd.html#VecScatterEnd">VecScatterEnd</A>  (vec1_B,z,<A href="../../../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>,<A href="../../../../../../docs/manualpages/Sys/SCATTER_REVERSE.html#SCATTER_REVERSE">SCATTER_REVERSE</A>,pcis-&gt;global_to_B);
<a name="line605">605: </a>  <font color="#4169E1">return</font>(0);
<a name="line606">606: </a>}




<a name="line612">612: </a><font color="#B22222">/*  -------   E N D   O F   T H E   C O D E   -------  */</font>
<a name="line613">613: </a><font color="#B22222">/*                                                     */</font>
<a name="line614">614: </a><font color="#B22222">/*  From now on, "footnotes" (or "historical notes").  */</font>
<a name="line615">615: </a><font color="#B22222">/*                                                     */</font>
<a name="line616">616: </a><font color="#B22222">/*  -------------------------------------------------  */</font>



<a name="line620">620: </a><font color="#B22222">/* --------------------------------------------------------------------------</font>
<a name="line621">621: </a><font color="#B22222">   Historical note 01 </font>
<a name="line622">622: </a><font color="#B22222">   -------------------------------------------------------------------------- */</font>
<a name="line623">623: </a><font color="#B22222">/*</font>
<a name="line624">624: </a><font color="#B22222">   We considered the possibility of an alternative D_i that would still</font>
<a name="line625">625: </a><font color="#B22222">   provide a partition of unity (i.e., $ \sum_i  N_i D_i N_i^T = I $).</font>
<a name="line626">626: </a><font color="#B22222">   The basic principle was still the pseudo-inverse of the counting</font>
<a name="line627">627: </a><font color="#B22222">   function; the difference was that we would not count subdomains</font>
<a name="line628">628: </a><font color="#B22222">   that do not contribute to the coarse space (i.e., not pure-Neumann</font>
<a name="line629">629: </a><font color="#B22222">   subdomains).</font>

<a name="line631">631: </a><font color="#B22222">   This turned out to be a bad idea:  we would solve trivial Neumann</font>
<a name="line632">632: </a><font color="#B22222">   problems in the not pure-Neumann subdomains, since we would be scaling</font>
<a name="line633">633: </a><font color="#B22222">   the balanced residual by zero.</font>
<a name="line634">634: </a><font color="#B22222">*/</font>




<a name="line639">639: </a><font color="#B22222">/* --------------------------------------------------------------------------</font>
<a name="line640">640: </a><font color="#B22222">   Historical note 02 </font>
<a name="line641">641: </a><font color="#B22222">   -------------------------------------------------------------------------- */</font>
<a name="line642">642: </a><font color="#B22222">/*</font>
<a name="line643">643: </a><font color="#B22222">   We tried an alternative coarse problem, that would eliminate exactly a</font>
<a name="line644">644: </a><font color="#B22222">   constant error. Turned out not to improve the overall convergence.</font>
<a name="line645">645: </a><font color="#B22222">*/</font>


</pre>
</body>

</html>
